'                                           EXAMPLE04
'
'                               DISPLAYS TEXT ON A VIDEO MONITOR                              
'*************************************************************************************************
'IMPORTANT: This example requires an understanding of examples 01, 02, and 03.
'*************************************************************************************************
'WHAT'S NEW IN THIS EXAMPLE:
'
'   TV_Terminal: This is an object that generates the signals necessary to drive a video monitor.
'
'   VideoDisplay: An instance of the object TV_Terminal.
'
'   Repeat Count From 1 To 5: This is a loop that will increment the variable, Count, from 1 to 5.
'                             The code under it is repeated five times.
'*************************************************************************************************
'DIFFICULTY LEVEL: Easy
'
'PURPOSE:
'  -- Demonstrates how to send text to a video monitor, and how to set the foreground and
'     background colors of a video monitor to white-on-blue.
'
'ADDITIONAL INFORMATION: 
'  -- The video signal output is a composite signal.
'  -- TV_Terminal is an object call TV_Terminal.spin found in the "Propeller Tool" subdirectory.
'  -- Any name could have been used instead of "VideoDisplay"
'  -- This examples requires an elementary knowledge of OOP.
'  -- This example assumes you have the development kit or a schematic of it.  
'     You will need one of these to generate a composite video out.
' 
'Submitted by Dave Scanlan, March 3, 2006          
'File: Example04_VideoOutput.spin
'**************************************************************************************************
'CORRECT OUTPUT: A text string and an incrementing decimal number will be displayed five times.
'**************************************************************************************************
'
CON
  _clkmode = xtal1 + pll16x       
  _xinfreq = 5_000_000
  NewLine = 13
  ClearScreen = 0
 ' 
OBJ
  VideoDisplay: "TV_Terminal"                   'Creates the object VideoDisplay
'
PUB Start
'
  DisplayTextOnMonitor
'
PRI DisplayTextOnMonitor | Count
  VideoDisplay.start                            'Initializes the VideoDisplay object
  SetScreenWhiteOnDarkBlue                      'Calls a procedure that sets the foreground
                                                '  color to white and the background color
                                                '  to dark blue.
'
  Repeat Count From 1 To 50000                  'For every loop, Count increments by one.
    WaitCnt(40_000_000 + Cnt) 
    VideoDisplay.str(string("THE COUNT IS: "))  'Sends a text string to the video monitor.
    VideoDisplay.dec(Count)                     'Sends a numeric value to a video monitor.
    VideoDisplay.out(NewLine)                   'Sends a NewLine to a video monitor.
    WaitCnt(40_000_000 + Cnt)
  VideoDisplay.out(ClearScreen)                 'Clear screen.
' 
PRI SetScreenWhiteOnDarkBlue                    'Sets the foreground color to white and the
  VideoDisplay.out(3)                           '  background color to dark blue on the monitor.
  VideoDisplay.out(5)

'INDENTION IS IMPORTANT IN SPIN:  Spin does not use Ends in its blocks of code.   For
'                                 example, there is no End Repeat after the Repeat loop and
'                                 you must indent after CON, OBJ, PUB, PRI, and DAT.
'